﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Data;
using Telerik.Windows.Controls;
using System.ComponentModel;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Threading;

namespace TestRadGridView
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        BackgroundWorker worker = new BackgroundWorker();

        public MainWindow()
        {
            InitializeComponent();
            DataContext = new ViewModel();
            var view = (this.DataContext as ViewModel).View;
            view.ItemsLoading += View_ItemsLoading;
            view.ItemsLoaded += View_ItemsLoaded;
            this.RadGridView.Grouping += RadGridView_Grouping;
            this.RadGridView.Grouped += RadGridView_Grouped;
            this.RadGridView.GroupRowIsExpandedChanging += RadGridView_GroupRowIsExpandedChanging;
            this.RadGridView.GroupRowIsExpandedChanged += RadGridView_GroupRowIsExpandedChanged;
        }

        private void RadGridView_GroupRowIsExpandedChanged(object sender, Telerik.Windows.Controls.GridView.GroupRowEventArgs e)
        {
            this.busyIndicator.IsBusy = false;
        }

        private void RadGridView_GroupRowIsExpandedChanging(object sender, Telerik.Windows.Controls.GridView.GroupRowCancelEventArgs e)
        {
            this.busyIndicator.IsBusy = true;
        }

        private void RadGridView_Grouped(object sender, GridViewGroupedEventArgs e)
        {
            this.busyIndicator.IsBusy = false;
        }

        private void RadGridView_Grouping(object sender, GridViewGroupingEventArgs e)
        {
            this.busyIndicator.IsBusy = true;
        }

        private void View_ItemsLoaded(object sender, VirtualQueryableCollectionViewItemsLoadedEventArgs e)
        {
            this.busyIndicator.IsBusy = false;
        }

        private void View_ItemsLoading(object sender, VirtualQueryableCollectionViewItemsLoadingEventArgs e)
        {
            this.busyIndicator.IsBusy = true;
        }
    }
}
